Attribute VB_Name = "modCalculate"
Option Explicit

Public Function kapRechne()
    clrTxtBox                       ' Alle Ausgabe-TextBoxen lschen
    fl = 0
    If dose = True Then
        inpZDm = frmhaupt.Text2(6).Text
        inpZLg = frmhaupt.Text2(7).Text
        fl = ((inpZDm * inpZLg * PI) + (inpZDm * inpZDm * PI / 4)) * 0.01
        frmhaupt.Text1(0) = Round(fl, 1)
        rechneKap
        rechneInd
        rechneRest
    ElseIf rohr = True Then
        inpRDm = frmhaupt.Text2(8).Text
        inpRLg = frmhaupt.Text2(9).Text
        fl = (inpRDm * inpRLg * PI) * 0.01
        frmhaupt.Text1(0) = Round(fl, 1)
        rechneKap
        rechneInd
        rechneRest
    ElseIf kugel = True Then
        inpKDm = frmhaupt.Text2(10).Text
        fl = (PI * inpKDm * inpKDm / 100) - (PI * inpKDm * inpKDm * 0.25 / 100)
        frmhaupt.Text1(0) = Round(fl, 1)
        rechneKugelKap
        rechneInd
        rechneRest
    ElseIf box = True Then
        inpSa = frmhaupt.Text2(1).Text
        inpSb = frmhaupt.Text2(2).Text
        inpSc = frmhaupt.Text2(3).Text
        fl = (2 * (inpSa * inpSb / 2 + inpSa * inpSc + inpSb * inpSc)) * 0.01
        frmhaupt.Text1(0) = Round(fl, 1)
        rechneKap
        rechneInd
        rechneRest
    ElseIf flaeche = True Then
        inpFl = frmhaupt.Text2(11).Text
        fl = inpFl
        frmhaupt.Text1(0) = Round(fl, 1)
        rechneKap
        rechneInd
        rechneRest
    End If
End Function
'
'###################################### Berecnungen ##########################################
'
'Kapazitt Dose/Rohr/Box/Flche berechnen
Public Function rechneKap()
    If fl > 0 And fl < 200 Then
        z = 0.035
        I = 0
    ElseIf fl >= 200 And fl < 1000 Then
        z = 0.0128
        I = 4
    ElseIf fl >= 1000 And fl < 2600 Then
        z = 0.0075
        I = 9
    ElseIf fl >= 2600 And fl < 5000 Then
        z = 0.0037
        I = 19
    ElseIf fl >= 5000 And fl < 9000 Then
        z = 0.0025
        I = 25
    ElseIf fl >= 9000 And fl <= 10000 Then
        z = 0.00184
        I = 31
    ElseIf fl > 10000 Then
        z = 0.00184
        I = 28
    ElseIf fl > 10000 And box = True Then
        z = 0.00184
        I = 31
    ElseIf fl > 10000 And flaeche = True Then
        z = 0.00184
        I = 31
    End If
    cap = (((fl * z) + I) * 10) / 10
    frmhaupt.Text1(1) = Round(cap, 2)
End Function

'Kapazitt Kugel berechnen
Public Function rechneKugelKap()
    If fl > 0 And fl < 200 Then
        z = 0.035
        I = 0
    ElseIf fl >= 200 And fl < 1000 Then
        z = 0.012
        I = 4
    ElseIf fl >= 1000 And fl < 2600 Then
        z = 0.007
        I = 9
    ElseIf fl >= 2600 And fl < 5000 Then
        z = 0.003
        I = 19
    ElseIf fl >= 5000 And fl < 9000 Then
        z = 0.002
        I = 25
    ElseIf fl >= 9000 And fl <= 10000 Then
        z = 0.0012
        I = 31
    ElseIf fl > 10000 Then
        z = 0.001
        I = 33
    End If
    cap = (((fl * z) + I) * 10) / 10
    frmhaupt.Text1(1) = Round(cap, 2)
End Function

'Induktivitt berechnen
Public Function rechneInd()
    inpFreq = frmhaupt.Text2(0).Text
    c = ((fl * z) + I)
    If box = True Then
        ind = ((25356 / (inpFreq * inpFreq * 1000000000000# * c _
        * 0.000000000001)) * 100) * 0.01
    Else
        ind = ((25330.296 / (inpFreq * inpFreq * 1000000000000# * c _
        * 0.000000000001)) * 100) * 0.01
    End If
    frmhaupt.Text1(2) = Round(ind, 2)
End Function
    
'Windungen/Spulenlnge/Drahtlnge/Anschlukabel (Lambda/4) berechnen
Public Function rechneRest()
    inpSDm = frmhaupt.Text2(4).Text
    inpDDm = frmhaupt.Text2(5).Text
    z1 = 1
    For l = 1 To 11
        m = Sqr(ind * (101.6 * z1 / 10 + 45.72 * inpSDm / 10) / (inpSDm * inpSDm / 100))
        z1 = m * inpDDm
    Next l
    z = z1
    frmhaupt.Text1(3) = Round((m * 10) / 10, 1)
    frmhaupt.Text1(4) = Round((z * 10) / 10, 1)
    frmhaupt.Text1(5) = Round((((inpSDm / 10 + inpDDm / 10) * PI * z) * 100) / 10000, 2)
    frmhaupt.Text1(6) = Round((300 / inpFreq / 4 * 0.66 * 100) / 100, 3)
End Function

