Attribute VB_Name = "modInfoBox"
Option Explicit

' Hilfs-Funktionen (Timer)
Private Declare Function SetTimer Lib "user32" ( _
  ByVal hWnd As Long, _
  ByVal nIDEvent As Long, _
  ByVal uElapse As Long, _
  ByVal lpTimerFunc As Long) As Long
 
Private Declare Function KillTimer Lib "user32" ( _
  ByVal hWnd As Long, _
  ByVal nIDEvent As Long) As Long
  
' kurze Erklrung zu den bentigten Variablen:
Public Geschwindigkeit As Long      ' empfohlen: von 2 bis 10
Public Textausrichtung As Byte      ' 0 = Links, 1 = Rechts, 2 = Zentriert
Public TextBreite As Single         ' von 0.6 bis 1 (1 = ganze Breite)
Public BildStretchen As Boolean     ' Bild in AusgabeObjekt einpassen
Public TextPfad As String           ' Text der ber die PicBox "luft"
Public BildPfad As String           ' Bild das im Hintergrund erscheint
 
Private AusgabeYPosition As Long    ' horizontale Text-Position
Private objAusgObjekt As Object     ' Form oder PictureBox
Private TimerLuft As Boolean
 
Private HilfsText As String         ' TextVariable
Private MaxTextWidth As Long
Private HilfsTextHhe As Long       ' ermittelte TextHhe
Private HilfsTextColor As Long
 
Private HilfsBild As StdPicture     ' BildVariable
Private BildWeite As Long
Private BildHhe As Long

Public Sub StarteLauftext(AusgabeObjekt As Object)
    With AusgabeObjekt
' AusgabeObjekt "leeren"
    .Cls
' Einstellungen setzen
      .ScaleMode = 1               ' Maeinheit auf Twips setzen
      .AutoRedraw = True
'      .Enabled = False
      If TextBreite < 0.6 Then
        MaxTextWidth = .ScaleWidth * 0.6
      ElseIf TextBreite > 1 Then
        MaxTextWidth = .ScaleWidth * 1
      Else
        MaxTextWidth = .ScaleWidth * TextBreite
      End If
' Textausgabe in PicBox am unteren Rand beginnen lassen
      If AusgabeYPosition = 0 Then AusgabeYPosition = .ScaleHeight
    End With
' Den Text in die Variable "HilfsText" einlesen, und dabei
' Wort- und Zeilenumbrche und Ausrichtung verarbeiten
    ReadMultilineText AusgabeObjekt, TextPfad, MaxTextWidth, Textausrichtung
' Um zu erfahren, wann der Lauftext den oberen Rand des
' AusgabeObjekts berschreitet, lesen wir die Texthhe aus
    HilfsTextHhe = AusgabeObjekt.TextHeight(HilfsText)
    'HilfsTextColor = AusgabeObjekt.ForeColor(HilfsText)
    HilfsTextColor = &H80FFFF
' Jetzt lassen wir mit Hilfe eines Timers den Text "laufen"
    Set objAusgObjekt = AusgabeObjekt   ' Objekt weiterreichen
    Call SetTimer(AusgabeObjekt.hWnd, 0, 10, AddressOf TimerProc1)
End Sub

' !WICHTIG! Timer killen, bevor die Anwendung beendet wird!
Public Sub KillTheTimer()
  If TimerLuft = True Then
    TimerLuft = False
    KillTimer objAusgObjekt.hWnd, 0
  End If
End Sub

' Mit Hilfe des Timers die Schrift "laufen lassen"
Sub TimerProc1(ByVal hWnd As Long, ByVal nIDEvent As Long, _
  ByVal uElapse As Long, ByVal lpTimerFunc As Long)
 
' .... hier Anweisungen fr Timer-Event
  On Error Resume Next
  TimerLuft = True
 
  With objAusgObjekt
' vorherige Text-Ausgabe lschen (Bild bleibt erhalten)
    .Cls
 
' Text ber das AusgabeObjekt "laufen lassen".
    If AusgabeYPosition > -HilfsTextHhe Then
' Text immer ein Stckchen hochsetzen
      AusgabeYPosition = AusgabeYPosition - Geschwindigkeit
    Else
' Text an den unteren Rand (AusgabeObjekt) setzen
      AusgabeYPosition = .ScaleHeight
    End If
 
    .CurrentY = AusgabeYPosition
 
' Text im AusgabeObjekt "drucken"
    objAusgObjekt.Print HilfsText
  End With
End Sub

Public Sub ReadMultilineText( _
  ByRef AusgabeObjekt As Object, _
  ByVal sText As String, _
  Optional ByVal MaxWidth As Long = 0, _
  Optional ByVal tAlign As Integer = 0)
 
  Dim FNr As Integer
  Dim sLine() As String
  Dim I As Integer
  Dim NextLine As String
  Dim ZeilenBreite
  Dim AusgabeEndpunkt
 
  ' Textdatei
    HilfsText = "" ' vorherigen Text lschen
    sText = "---==o[ ABOUT ]o==---" & vbCrLf & vbCrLf _
        & "Antenna Calculating Programm" & vbCrLf & "for small shortwaveantennas" & vbCrLf _
        & "called" & vbCrLf & vbCrLf & "' KAP '" & vbCrLf & vbCrLf _
        & "Copyright by DL7AHW" & vbCrLf & vbCrLf _
        & "Graphical User Interface" & vbCrLf & "written by DDYU" & vbCrLf & vbCrLf _
        & "---==o<0>o==---" & vbCrLf & vbCrLf _
        & "Many thanks for translation" & vbCrLf & "in alphabetical order" & vbCrLf & vbCrLf _
        & "OM Paul DL5MEC (czech)" & vbCrLf _
        & "OM Wolfram SV1QFI (greece)" & vbCrLf & vbCrLf _
        & "if you want to help translate in" & vbCrLf _
        & "your language so do it with" & vbCrLf _
        & "language tool and contact DDYU" & vbCrLf _
        & "via homepage for integrating your" & vbCrLf _
        & "*.lng file and your callsign here" & vbCrLf _
        & "many thanks" & vbCrLf & vbCrLf _
        & "---==o<0>o==---" & vbCrLf & vbCrLf & "Background Picture" & vbCrLf & "is a KAP for 40m" & vbCrLf & vbCrLf _
        & "more on" & vbCrLf & "http://dl7ahw.bplaced.net" & vbCrLf & "or" & vbCrLf & "www.dd0yu.com" & vbCrLf & vbCrLf _
        & "---==o<0>o==---" & vbCrLf & vbCrLf & "This program Is freeware" & vbCrLf & "and it's written" & vbCrLf _
        & "by" & vbCrLf & "--< OldMan's 4 OldMan's >--" & vbCrLf & vbCrLf & "good dx & have fun" & vbCrLf & "73 es 55" & vbCrLf & vbCrLf _
        & "Arthur DL7AHW" & vbCrLf & vbCrLf _
        & "click on image to" & vbCrLf _
        & "close this window"
 
  With AusgabeObjekt
    ' zunchst die "harten" Zeilenumbrche ermitteln
    sLine = Split(sText, vbCrLf)
    For I = 0 To UBound(sLine)
      ' Zeile hat keine "berbreite"
      If .TextWidth(sLine(I)) <= MaxWidth Then
        ' Ausrichtung
        ZeilenBreite = .TextWidth(sLine(I))
        Select Case tAlign
          Case 1
            ' rechtsbndig
            AusgabeEndpunkt = MaxWidth + (.ScaleWidth - MaxWidth) / 2
          Case 2
            ' zentriert
            AusgabeEndpunkt = ZeilenBreite + (.ScaleWidth - ZeilenBreite) / 2
          Case Else
            ' linksbndig
            AusgabeEndpunkt = ZeilenBreite + (.ScaleWidth - MaxWidth) / 2
        End Select
        ' je nach Ausrichtung Zeile (links) mit
        ' entsprechend vielen Leerzeichen auffllen
        Do Until ZeilenBreite >= AusgabeEndpunkt
          sLine(I) = " " & sLine(I)
          ZeilenBreite = .TextWidth(sLine(I))
        Loop
        ' Zeile in Variable hinzufgen
        HilfsText = HilfsText & sLine(I) & vbCrLf
      Else
        ' Zeile umbrechen
        Do
          NextLine = ""
          While .TextWidth(sLine(I)) > MaxWidth
            NextLine = Right$(sLine(I), 1) + NextLine
            sLine(I) = Left$(sLine(I), Len(sLine(I)) - 1)
          Wend
          ' Wortumbruch prfen
          CheckUmbruch NextLine, sLine(I)
          ' Ausrichtung
          ZeilenBreite = .TextWidth(sLine(I))
          Select Case tAlign
            Case 1
              ' rechtsbndig
              AusgabeEndpunkt = MaxWidth + (.ScaleWidth - MaxWidth) / 2
            Case 2
              ' zentriert
              AusgabeEndpunkt = ZeilenBreite + (.ScaleWidth - ZeilenBreite) / 2
            Case Else
              ' linksbndig
              AusgabeEndpunkt = ZeilenBreite + (.ScaleWidth - MaxWidth) / 2
          End Select
          ' je nach Ausrichtung Zeile (links) mit
          ' entsprechend vielen Leerzeichen auffllen
          Do Until ZeilenBreite >= AusgabeEndpunkt
            sLine(I) = " " & sLine(I)
            ZeilenBreite = .TextWidth(sLine(I))
          Loop
          ' Zeile in Variable hinzufgen
          HilfsText = HilfsText & sLine(I) & vbCrLf
          sLine(I) = NextLine
        Loop Until Trim$(sLine(I)) = ""
      End If
    Next I
  End With
End Sub

' Hilfsroutine
' korrekten Wortumbruch beachten
Private Sub CheckUmbruch(NextLine As String, Text As String)
  Const Check = " .,;:-_!?(/+=*~"
  If NextLine <> "" Then
    If InStr(Check, Left$(NextLine, 1)) = 0 Then
      While InStr(Check, Right$(Text, 1)) = 0 And Len(Text) > 0
        NextLine = Right$(Text, 1) + NextLine
        Text = Left$(Text, Len(Text) - 1)
      Wend
    End If
  End If
End Sub

