Attribute VB_Name = "modCheckKey"
Option Explicit
'
'################################# Tastaturabfrage Start ###########################################
'
' TextBox zur Eingabe focussieren
Public Sub Text2_GotFocus(index As Integer)
    With frmHaupt.Text2(index)
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub

' Komma als Dezimaltrennzeichen verwenden - nur positive Werte erlaubt
Public Sub Text2_KeyPress(index As Integer, KeyAscii As Integer)
    CheckNumericInput frmHaupt.Text2(index), KeyAscii, False
End Sub

'Zulssige Zeichen fr Maangaben
Public Sub CheckNumericInput( _
  oText As TextBox, KeyAscii As Integer, _
  Optional ByVal bAllowNegativeValues As Boolean = True, _
  Optional ByVal sDecimalChar As String = ",")
  Dim nDecimal As Integer
  If sDecimalChar <> "" Then nDecimal = Asc(sDecimalChar)
  With oText
    Select Case KeyAscii
      Case 48 To 57, nDecimal, 8, 13
        ' Zahlen, Dezimalzeichen, Backspace und ENTER
 
      Case 44, 46
        ' Aus Komma mach Punkt bzw. umgekehrt
        KeyAscii = nDecimal
 
      Case 45
        ' Minuszeichen nur als erstes Zeichen zulassen
        If .SelStart > 0 Or Not bAllowNegativeValues Then KeyAscii = 0
 
      Case Else
        ' alle anderen Zeichen nicht erlaubt!
        KeyAscii = 0
    End Select
    ' Dezimalzeichen darf nur 1 x eingegeben werden!
    If (KeyAscii = nDecimal And nDecimal > 0) Then
      If InStr(.Text, Chr$(nDecimal)) > 0 Then KeyAscii = 0
    End If
  End With
End Sub


